<template>
  <div class="non-financial-adjustment">
    <div class="table-block">
      <ObTable
        :items="currentList"
        :columns="columns"
        @select="$emit('on-select', $event)"
        class="non-financial-adjustment__list"
      >
        <SlotTitle
          slot="title"
          slot-scope="{ data }"
          :service="data.item"
          :order="order"
        />
        <template v-slot:createdAt="{ data }">
          <div
            class="correction-document"
            :class="{
              '--with-1x-date': Boolean(data.item.correctionDocument1cDt)
            }"
          >
            <div
              class="correction-document__title"
            >
              <div>
                <span>{{ data.item.createdAt | date('DD.MM.YYYY') }}</span>
                <span class="field-time">{{ data.item.createdAt | date('HH:mm') }}</span>
              </div>
              <FilesDropdown
                class="files-dropdown"
                :file-uuids="data.item.fileUuids || []"
              />
            </div>
            <SlotCorrectionDocument
              :service="data.item"
              :order="order"
              :is-only-document="true"
            />
          </div>
        </template>

      </ObTable>
      <div
        v-if="isShowAddButton"
        class="table-block__panel"
      >
        <button
          class="add-button"
          @click="onAddCorrection"
        >
          <i class="icon plus" />
          <span>Добавить Корректировку</span>
        </button>
        <CorrectionDocument
          :order="order"
          :corrections="currentList"
          :is-mini="true"
          class="correction-document-button"
        />
      </div>
    </div>
    <CorrectionForm
      ref="correctionForm"
      :order="order"
      :data-source="selectedCorrection"
      @submitted="updateList"
    />
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import CorrectionForm from '@/components/Order/orderItem/services/nonFinancialAdjustment/form'
import ObTable from 'common-components/src/obComponents/obTable'
import SlotTitle from '@/components/Order/orderItem/services/additionalServices/slots/tableTitle'
import FilesDropdown from '@/components/Order/filesDropdown'
import CorrectionDocument from "@/components/Order/orderItem/services/CorrectionDocument"
import SlotCorrectionDocument from '@/components/Order/orderItem/services/additionalServices/slots/correctionDocument'

export default {
  name: 'OrderNonFinancialAdjustment',
  props: {
    order: {
      type: Object,
      required: true
    },
    corrections: {
      type: Array,
      default: () => []
    },
  },
  components: {
    CorrectionForm,
    ObTable,
    SlotTitle,
    FilesDropdown,
    CorrectionDocument,
    SlotCorrectionDocument
  },
  data () {
    return {
      selectedCorrection: {}
    }
  },
  computed: {
    ...mapGetters({
      nonFinancialAdjustments: 'order/nonFinancialAdjustments',
      additionalServices: 'order/additionalServices',
      isClicar: 'user/isClicar'
    }),
    isCreatingDocument () {
      return this.isClicar && this.currentList.some(item => item.status === 'APPROVED' && !item.correctionDocumentNumber)
    },
    isExistSent1cStatus () {
      return [ ...this.currentCorrections, ...this.currentList ].some(item => item.correctionDocument1cStatus === 'SENT')
    },
    currentCorrections () {
      const list = this.order && this.additionalServices ? this.additionalServices[this.order.uuid] || []: []
      return list.filter((item) => item.serviceKind === 'CORRECTION')
    },
    currentList () {
      return this.nonFinancialAdjustments[this.order?.uuid] || []
    },
    isShowAddButton () {
      if (['CANCELLED', 'FAILED' ].includes(this.order.status)) {
        return false
      }

      return this.isClicar && !this.order.isEditable && !this.isExistSent1cStatus
    },
    columns () {
      return [
        {
          title: 'наименование',
          key: 'title',
          slotName: 'title'
        },
        {
          title: 'номер',
          key: 'adjustmentNumber'
        },
        {
          title: 'создано',
          key: 'createdAt',
          slotName: 'createdAt'
        },

      ]
    }
  },
  methods: {
    ...mapActions({
      getNonFinancialAdjustments: 'order/getNonFinancialAdjustments'
    }),
    onAddCorrection () {
      this.$refs.correctionForm.open()
    },
    updateList () {
      this.getNonFinancialAdjustments({ uuid: this.order.uuid })
    },
    createCorrectionDocument () {
      console.log('createCorrectionDocument')
    },
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.non-financial-adjustment {
  .table-block {
    border-style: solid;
    border-color: $lavender;
    border-width: 1px 1px 0 1px;
    border-radius: 3px;
    &__panel {
      padding: 10px 20px;
      border-bottom: 1px solid $lavender;
      .add-button {
        display: flex;
        align-items: center;
        height: 40px;
        background-color: transparent;
        border: none;
        outline: none;
        cursor: pointer;
        @include font-mixin(14px, 18px, 400, $color-blue-navy-blue, 0.2px);
        i {
          font-size: 16px;
          margin-right: 6px;
        }
        &:hover {
          opacity: 0.8;
        }
      }
      .correction-document-button {
        margin-top: 30px;
        margin-bottom: 18px;
        &:empty {
          display: none;
        }
      }
    }
    &::v-deep {
      .table-panel-inner {
        overflow: visible!important;
      }
      table {
        min-width: auto;
        thead tr th {
          border-top: none!important;
        }
        td {
          vertical-align: top;
          .td-container {
            padding-top: 20px;
            padding-bottom: 20px;
            white-space: nowrap;
          }
          &:last-child {
            .td-container {
              & > div {
                width: 100%;
              }
            }
          }
        }
      }
      .correction-document {
        display: flex;
        flex-direction: column;
        text-align: right;
        &.--with-1x-date {
          min-height: 70px;
        }
        .files-dropdown {
          width: 50px;
          position: relative;
          top: 4px;
          left: 15px;
          margin-left: -5px;
          .menu-button {
            min-width: 50px;
            padding-left: 0!important;
          }
        }
        &__title {
          display: flex;
          align-items: center;
          justify-content: flex-end;
        }
        &__info {
          position: absolute;
          top: 52px;
          right: 18px;
          display: flex;
          align-items: flex-end;
          @include font-mixin(14px, 16px, 400, $green-800);
          .icon {
            margin-right: 8px;
            font-size: 16px;
          }
        }
      }
    }
  }
}
</style>